'Copyright (C) Richard L Grier 2010

Public Class frmCounterTest
    Inherits System.Windows.Forms.Form

    'Create a new MccBoard object for Board 0
    Private DaqBoard As MccDaq.MccBoard = New MccDaq.MccBoard(0)
    Const CounterNum As Short = 1 ' number of counter used
    Dim RegName As MccDaq.CounterRegister = MccDaq.CounterRegister.LoadReg1
    Friend WithEvents MenuStrip1 As System.Windows.Forms.MenuStrip
    Friend WithEvents ExitToolStripMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents ConfigureToolStripMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents AToolStripMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents Label1 As System.Windows.Forms.Label
    ' register name of counter 1
    Private StopWatch As New Stopwatch

    Private Sub tmrReadCounter_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrReadCounter.Tick
        Dim ULStat As MccDaq.ErrorInfo
        Dim Count As System.UInt32

        ULStat = DaqBoard.CIn32(RegName, Count)
        If ULStat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then Stop

        Dim Frequency As UInt32 = Count * 1000 / StopWatch.ElapsedMilliseconds

        ULStat = DaqBoard.CLoad32(RegName, 0)
        If ULStat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then Stop
        StopWatch.Reset()
        StopWatch.Start()

        lblShowCountRead.Text = Frequency.ToString("0")

    End Sub

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        InitUL()

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents tmrReadCounter As System.Windows.Forms.Timer
    Public WithEvents lblShowCountRead As System.Windows.Forms.Label
    Public WithEvents lblCountRead As System.Windows.Forms.Label
    Public WithEvents lblNoteFreqIn As System.Windows.Forms.Label
    Public WithEvents lblDemoFunction As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.tmrReadCounter = New System.Windows.Forms.Timer(Me.components)
        Me.lblShowCountRead = New System.Windows.Forms.Label
        Me.lblCountRead = New System.Windows.Forms.Label
        Me.lblNoteFreqIn = New System.Windows.Forms.Label
        Me.lblDemoFunction = New System.Windows.Forms.Label
        Me.MenuStrip1 = New System.Windows.Forms.MenuStrip
        Me.ExitToolStripMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.ConfigureToolStripMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.AToolStripMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.Label1 = New System.Windows.Forms.Label
        Me.MenuStrip1.SuspendLayout()
        Me.SuspendLayout()
        '
        'tmrReadCounter
        '
        Me.tmrReadCounter.Interval = 1000
        '
        'lblShowCountRead
        '
        Me.lblShowCountRead.BackColor = System.Drawing.SystemColors.Window
        Me.lblShowCountRead.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblShowCountRead.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblShowCountRead.FlatStyle = System.Windows.Forms.FlatStyle.Popup
        Me.lblShowCountRead.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblShowCountRead.ForeColor = System.Drawing.Color.Blue
        Me.lblShowCountRead.Location = New System.Drawing.Point(199, 96)
        Me.lblShowCountRead.Name = "lblShowCountRead"
        Me.lblShowCountRead.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblShowCountRead.Size = New System.Drawing.Size(50, 17)
        Me.lblShowCountRead.TabIndex = 20
        '
        'lblCountRead
        '
        Me.lblCountRead.BackColor = System.Drawing.SystemColors.Window
        Me.lblCountRead.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblCountRead.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblCountRead.ForeColor = System.Drawing.SystemColors.WindowText
        Me.lblCountRead.ImageAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.lblCountRead.Location = New System.Drawing.Point(96, 96)
        Me.lblCountRead.Name = "lblCountRead"
        Me.lblCountRead.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblCountRead.Size = New System.Drawing.Size(97, 17)
        Me.lblCountRead.TabIndex = 18
        Me.lblCountRead.Text = "Pulses per second"
        '
        'lblNoteFreqIn
        '
        Me.lblNoteFreqIn.BackColor = System.Drawing.SystemColors.Window
        Me.lblNoteFreqIn.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblNoteFreqIn.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblNoteFreqIn.ForeColor = System.Drawing.Color.Red
        Me.lblNoteFreqIn.Location = New System.Drawing.Point(12, 61)
        Me.lblNoteFreqIn.Name = "lblNoteFreqIn"
        Me.lblNoteFreqIn.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblNoteFreqIn.Size = New System.Drawing.Size(324, 19)
        Me.lblNoteFreqIn.TabIndex = 16
        Me.lblNoteFreqIn.Text = "NOTE: Apply a 5V (nominal) pulse input to Screw Terminal  Pin 20"
        Me.lblNoteFreqIn.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'lblDemoFunction
        '
        Me.lblDemoFunction.BackColor = System.Drawing.SystemColors.Window
        Me.lblDemoFunction.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblDemoFunction.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblDemoFunction.ForeColor = System.Drawing.SystemColors.WindowText
        Me.lblDemoFunction.Location = New System.Drawing.Point(55, 39)
        Me.lblDemoFunction.Name = "lblDemoFunction"
        Me.lblDemoFunction.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblDemoFunction.Size = New System.Drawing.Size(249, 22)
        Me.lblDemoFunction.TabIndex = 15
        Me.lblDemoFunction.Text = "USB-1208 HS Frequency Counter"
        Me.lblDemoFunction.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'MenuStrip1
        '
        Me.MenuStrip1.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.ExitToolStripMenuItem, Me.ConfigureToolStripMenuItem, Me.AToolStripMenuItem})
        Me.MenuStrip1.Location = New System.Drawing.Point(0, 0)
        Me.MenuStrip1.Name = "MenuStrip1"
        Me.MenuStrip1.Size = New System.Drawing.Size(355, 24)
        Me.MenuStrip1.TabIndex = 21
        Me.MenuStrip1.Text = "MenuStrip1"
        '
        'ExitToolStripMenuItem
        '
        Me.ExitToolStripMenuItem.Name = "ExitToolStripMenuItem"
        Me.ExitToolStripMenuItem.Size = New System.Drawing.Size(37, 20)
        Me.ExitToolStripMenuItem.Text = "Exit"
        '
        'ConfigureToolStripMenuItem
        '
        Me.ConfigureToolStripMenuItem.Name = "ConfigureToolStripMenuItem"
        Me.ConfigureToolStripMenuItem.Size = New System.Drawing.Size(138, 20)
        Me.ConfigureToolStripMenuItem.Text = "Configure Reset Interval"
        '
        'AToolStripMenuItem
        '
        Me.AToolStripMenuItem.Name = "AToolStripMenuItem"
        Me.AToolStripMenuItem.Size = New System.Drawing.Size(48, 20)
        Me.AToolStripMenuItem.Text = "About"
        '
        'Label1
        '
        Me.Label1.AutoSize = True
        Me.Label1.Location = New System.Drawing.Point(96, 128)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(39, 13)
        Me.Label1.TabIndex = 22
        Me.Label1.Text = "Label1"
        '
        'frmCounterTest
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.SystemColors.Window
        Me.ClientSize = New System.Drawing.Size(355, 167)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.lblShowCountRead)
        Me.Controls.Add(Me.lblCountRead)
        Me.Controls.Add(Me.lblNoteFreqIn)
        Me.Controls.Add(Me.lblDemoFunction)
        Me.Controls.Add(Me.MenuStrip1)
        Me.MainMenuStrip = Me.MenuStrip1
        Me.Name = "frmCounterTest"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Pulse/Event Counter"
        Me.MenuStrip1.ResumeLayout(False)
        Me.MenuStrip1.PerformLayout()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region





#Region "Universal Library Initialization - Expand this region to change error handling, etc."

    Private Sub InitUL()

        Dim RegName As MccDaq.CounterRegister
        Dim LoadValue As UInt32
        Dim ULStat As MccDaq.ErrorInfo

        ' Initiate error handling
        '  activating error handling will trap errors like
        '  bad channel numbers and non-configured conditions.
        '  Parameters:
        '    MccDaq.ErrorReporting.PrintAll :all warnings and errors encountered will be printed
        '    MccDaq.ErrorHandling.StopAll   :if any error is encountered, the program will stop
        ULStat = MccDaq.MccService.ErrHandling(MccDaq.ErrorReporting.PrintAll, MccDaq.ErrorHandling.StopAll)
        If ULStat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            Stop
        End If


        ' Reset the event counter with Mccdaq.MccBoard.CLoad32()
        '  Parameters:
        '    RegName    :the counter to be loaded with the starting value
        '    LoadValue  :the starting value to place in the counter
        RegName = MccDaq.CounterRegister.LoadReg1
        LoadValue = Convert.ToUInt32(0) ' Event counters can only be reset to 0
        ULStat = DaqBoard.CLoad32(RegName, LoadValue)

        tmrReadCounter.Enabled = True
    End Sub

#End Region


    Private Sub frmCounterTest_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        StopWatch.Start()
        tmrReadCounter.Interval = My.Settings.ResetInterval
        Label1.Text = "Timer reset interval: " & tmrReadCounter.Interval / 1000 & " s."
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub ConfigureToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConfigureToolStripMenuItem.Click
        Dim TimeInterval As Double = CDbl(InputBox("Timer reset interval in seconds", "Reset counter", CStr(tmrReadCounter.Interval / 1000)))
        If TimeInterval > 0.001 Then
            tmrReadCounter.Interval = CInt(TimeInterval * 1000)
            Label1.Text = "Timer reset interval: " & tmrReadCounter.Interval / 1000 & " s."
            My.Settings.ResetInterval = tmrReadCounter.Interval
        Else
            MsgBox("Interval must be greater than 0.001 seconds")
        End If
    End Sub

    Private Sub AToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AToolStripMenuItem.Click
        MsgBox("Simple Frequency/Event Counter that uses the Measurement Computing USB-2108FS" & vbLf & _
               vbLf & "The maximum practical pulse rate with this hardare is about 42K pps." & vbLf & vbLf & _
               "Copyright (C) Richard L. Grier 2010" & vbLf & "Hard & Software  www.hardandsoftware.net")
    End Sub
End Class
